package NTLSystem.support;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;

/**
 * A class which adapts a ListModel into a ComboBoxModel.  This class
 * stores the selected object, and otherwise passes calls onto the
 * ListModel.
 * <P>
 * $Id: ComboBoxModelAdaptor.java,v 1.2 1998/09/03 02:47:16 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 *
 * @author    Joshua Sled [jsled@icsi.berkeley.edu]
 * @see       com.sun.java.swing.ComboBoxModel
 * @see       com.sun.java.swing.ListModel
 * @version   $Revision: 1.2 $
 **/
public class ComboBoxModelAdaptor
    implements ComboBoxModel
{
    /**
     * The ListModel to pass calls through to.
     **/
    private ListModel lm;
    /**
     * The selected object... the only data that a ComboBoxModel is
     * really responsbile for.
     **/
    private Object sel;

    public ComboBoxModelAdaptor(ListModel lm)
    {
	this.lm = lm;
	sel = null;
    }
    
    public void addListDataListener(ListDataListener l) 
    {
	lm.addListDataListener( l );
    }

    public Object getElementAt(int index)
    {
	return lm.getElementAt( index );
    }

    public int getSize()
    {
	return lm.getSize();
    }

    public void removeListDataListener(ListDataListener l)
    {
	lm.removeListDataListener( l );
    }

    public Object getSelectedItem()
    { return sel; }

    public void setSelectedItem( Object o )
    {
	sel = o;
    }
    
}
