package NTLSystem.support;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;

/**
 * Support for drawing a property value in a Canvas.
 * <P>
 * Taken from the BDK.
 * <P>
 * $Id: PropertyCanvas.java,v 1.3 1998/06/23 23:27:59 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 *
 * @version $Revision: 1.3 $
 **/
class PropertyCanvas extends Canvas implements MouseListener {

    PropertyCanvas(Frame frame, PropertyEditor pe) {
	this.frame = frame;
	editor = pe;
	addMouseListener(this);
    }

    public void paint(Graphics g) {
	Rectangle box = new Rectangle(2, 2, getSize().width - 4, getSize().height - 4);
	editor.paintValue(g, box);
    }

  /**
   * Returns the minimum size of any canvas, which is 50 x 30.
   **/
  public Dimension getMinimumSize()
  {
    return new Dimension(50, 30);
  }

  /**
   * Returns the prefered size of a canvas, which is about 200x30.
   **/
  public Dimension getPreferedSize()
  {
    return new Dimension(200, 30);
  }

    private static boolean ignoreClick = false;

    public void mouseClicked(MouseEvent evt) {
	if (! ignoreClick) {
	    try {
		ignoreClick = true;
		int x = frame.getLocation().x - 30;
		int y = frame.getLocation().y + 50;
		new PropertyDialog(frame, editor, x, y);
	    } finally {
		ignoreClick = false;
	    }
	}
    }

    public void mousePressed(MouseEvent evt) {
    }

    public void mouseReleased(MouseEvent evt) {
    }

    public void mouseEntered(MouseEvent evt) {
    }

    public void mouseExited(MouseEvent evt) {
    }

    private Frame frame;
    private PropertyEditor editor;
}
