package NTLSystem.support;

import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

/**
 * Support for a PropertyEditor that uses text.
 * <P>
 * $Id: PropertyText.java,v 1.7 1998/07/15 02:40:47 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 *
 * @version $Revision: 1.7 $
 **/
class PropertyText
extends JTextField
implements KeyListener {

  PropertyText(PropertyEditor pe) {
    super( pe.getAsText(), 20);
    editor = pe;
    addKeyListener(this);

    acceptChars = true;
  }

  //----------------------------------------------------------------------
  // Keyboard listener methods.

  public void keyReleased(KeyEvent e) {
  }

  public void keyPressed(KeyEvent e) {
  }

  public void keyTyped(KeyEvent e) {
    if (acceptChars) {
      try {
	editor.setAsText(getText());
      } catch (IllegalArgumentException ex) {
	if (! getText().equals("")) {
	  acceptChars = false;
	  JOptionPane.showMessageDialog(this,
					getText() + " of wrong type for this field.",
					"Invalid value",
					JOptionPane.ERROR_MESSAGE);
	  acceptChars = true;
	} // end if
      } // end try-catch
    } // end if
  } // end keyTyped(KeyEvent)

  //----------------------------------------------------------------------
  private PropertyEditor editor;
  private boolean acceptChars;
}
