(Nancy notes to self -- need these in feature or distribution)

  /**
   * Get peakedness of this DiscreteDist.
   * A heuristic measure of the peakedness of the distribution.
   * Return infinity for a deterministic value or distribution-dependent result.
   **/
  public double peakedness() { 
    String ru = this.runnerUp();
    if (ru == null)
      return Double.POSITIVE_INFINITY;
    return likelihood(mode()) / likelihood(ru);
  }


  // Return the second-highest-probability feature value for this 
  // distribution (or null if there is only one feature in the dist).
  private String runnerUp() { 
    String leadingVal = null;
    double leadingCount = -1;
    String runnerUpVal = null;
    double runnerUpCount = -1;
    Enumeration valEnum = counts.keys();
    while (valEnum.hasMoreElements()) {
      String val = (String)valEnum.nextElement();
      double count = getCount(val);
      if (count > leadingCount) {
	runnerUpVal = leadingVal;
	runnerUpCount = leadingCount;
	leadingVal = val;
	leadingCount = count;
      }
      else if (count > runnerUpCount) {
	runnerUpVal = val;
	runnerUpCount = count;
      }
    }
    return runnerUpVal;
  }





GOES IN FEATURE


  /**
   * Get peakedness of this feature: 
   * A heuristic measure of the peakedness of the distribution.
   * Depends on distribution; haven't handled for continuous yet, Gaussian. FIXME!!
   * Return infinity for a deterministic value or distribution-dependent result.
   **/
  public double peakedness() { 
    if (value instanceof DiscreteDist) 
      {
	return value.peakedness();
      }
    else return Double.POSITIVE_INFINITY;
  }



