package NTLSystem.verblearn;

import java.io.*;
import java.util.*;
import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import NTLSystem.support.*;


///////////////////////////////////////////////////////////////////////
// Choice box for choosing a stored lexicon file.

class LexiconChoice extends Panel implements Observer {

  private Choice choice;
  private String currentLangslot;
  private Params currentParams;

  LexiconChoice() {
    add(new Label("Pick a lexicon to start with:"));
    rebuild();
    VerbLearn.context().addObserver(this);
    update(VerbLearn.context(), null);
  }

  public boolean action(Event e, Object arg) {
    if (arg.equals("None yet")) VerbLearn.context().setLexicon(null);
    else VerbLearn.context().setLexicon((String)arg);
    VerbLearn.lexiconPanel().rebuildLexiconGrid();
    VerbLearn.obeyPanel().rebuildCommandEntryGrid();
    return true;
  }

  public void update(Observable o, Object junk) {
    Context c = (Context)o;
    rebuild();
    String sel;
    if (c.lexicon() != null) sel = c.lexicon().id();
    else sel = "None yet";
    choice.select(sel);
  }

  private void rebuild() {
    if (choice != null) {
      remove(choice);
    }
    choice = new Choice();
    choice.addItem("None yet");
    if (VerbLearn.context().lang() != null &&
	 VerbLearn.context().params() != null) {
      choice.addItem("New/Unnamed");
      if (VerbLearn.context().lexiconList() != null) {
	for (int i = 0; i < VerbLearn.context().lexiconList().length; i++) {
	  choice.addItem(VerbLearn.context().lexiconList()[i]);
	}
      }
    }
    add(choice);
    currentLangslot = VerbLearn.context().langslot();
    currentParams = VerbLearn.context().params();
    // validate();  // refreshes panel -- got idea from netnews
    if (VerbLearn.lexiconPanel() != null) {
      VerbLearn.lexiconPanel().rebuildLexiconGrid();
      VerbLearn.obeyPanel().rebuildCommandEntryGrid();
    }
  }
}
    
