package NTLSystem.verblearn;

import java.io.*;
import java.util.*;
import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import NTLSystem.support.*;


///////////////////////////////////////////////////////////////////////
// Choice box for choosing a parameter file.

class ParamChoice extends Panel implements Observer {

  private Choice choice;

  ParamChoice() {
    add(new Label("Pick a parameter file:"));
    VerbLearn.context().addObserver(this);
    update(VerbLearn.context(), null);
  }

  public boolean action(Event e, Object arg) {
    if (arg.equals("None yet")) VerbLearn.context().setParams((String)null);
    else VerbLearn.context().setParams((String)arg);
    return true;
  }

  public void update(Observable o, Object junk) {
    Context c = (Context)o;
    rebuild();
    String sel;
    if (c.params() != null) sel = c.params().id();
    else sel = "None yet";
    choice.select(sel);
  }

  private void rebuild() {
    if (choice != null) {
      remove(choice);
    }
    choice = new Choice();
    choice.addItem("None yet");
    for (int i = 0; i < VerbLearn.context().paramList().length; i++) {
      choice.addItem(VerbLearn.context().paramList()[i]);
    }
    add(choice);
    // validate();  // refreshes panel -- got idea from netnews
  }
}
